using SharedKernel.Helpers;
using Application.Abstractions.Messaging;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;

namespace Admin.Pages.Document
{
    public class IndexModel(IMediator mediator) : PageModel
    {
        [BindProperty(SupportsGet = true)]
        public QueryParams Query { get; set; } = new();

        public sealed class QueryParams
        {
            [Range(1, int.MaxValue)]
            [DisplayName("??? ??")]
            public int PageNum { get; set; } = 1;

            [Range(1, 100)]
            [DisplayName("??? ?? ?")]
            public ushort PerPage { get; set; } = 10;
        }

        public int Total { get; set; } = 0;
        public List<(
            int Num,
            int ID,
            string Link,
            string Code,
            string Subject,
            string? Content,
            char IsActive,
            string Views,
            string? UpdatedAt,
            string CreatedAt,
            string EditURL
        )> List { get; set; } = [];

        public Pagination? Pagination { get; set; }

        public async Task OnGetAsync(CancellationToken ct)
        {
            if (!ModelState.IsValid)
            {
                return;
            }

            var result = await mediator.Send(new SearchDocuments.Query(Query.PageNum, Query.PerPage), ct);

            Total = result.Total;
            List = [..result.List.Select(c => (
                c.Num,
                c.ID,
                c.Link,
                c.Code,
                c.Subject,
                c.Content,
                c.IsActive,
                c.Views,
                c.UpdatedAt,
                c.CreatedAt,
                EditURL: $"/Document/Edit/{c.ID}{Request.QueryString}"
            ))];


            Pagination = new Pagination(result.Total, Query.PageNum, Query.PerPage);
        }

        public async Task<IActionResult> OnPostDeleteAsync(int[] ids, CancellationToken ct)
        {
            try
            {
                await mediator.Send(new DeleteDocument.Command(ids), ct);

                TempData["SuccessMessage"] = $"{ids.Length}? ??? ???????.";
            }
            catch (Exception e)
            {
                TempData["ErrorMessages"] = e.Message;
            }

            return RedirectToPage("/Document/Index", Query);
        }
    }
}